Unit ML0822_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ML0822(var X :Array of Real; M1 :Integer;
                var XK :Array of Real; K :Integer; var L :Integer;
                var TETA :Real; EPS :Real; var ALFA :Array of Real;
                KV :Integer; var NA :Integer;
                var NALFA :Array of Integer;
                var NX :Array of Integer);

implementation

procedure ML0822(var X :Array of Real; M1 :Integer;
                var XK :Array of Real; K :Integer; var L :Integer;
                var TETA :Real; EPS :Real; var ALFA :Array of Real;
                KV :Integer; var NA :Integer;
                var NALFA :Array of Integer;
                var NX :Array of Integer);
var
I,J,K1,K2,K3,K6,M :Integer;
A,EPS1,R :Real;
const
O16000 :Integer = 16000;
label
_10,_20,_30,_40,_50,_60,_70,_80;
begin
EPS1 := 0.1E-8;
NA := 0;
M := M1 - 1;
TETA := 10.E+10;
A := -1;
for I:=1 to KV do
 begin
  K1 := NALFA[I-1];
  K2 := K1;
  if ( K1 > O16000 ) 
   then K2 := K1 -O16000;
  if ( K2 =  K ) 
   then goto _20;
_10:
 end;
goto _40;
_20:
A := ALFA[I-1];
TETA := A;
NA := I;
if ( K1 =  K2 ) 
 then goto _40;
for I:=1 to M do
 begin
  XK[I-1] := -XK[I-1];
_30:
 end;
_40:
for I:=1 to M do
 begin
  if ( Abs(XK[I-1]) <  EPS ) 
   then goto _80;
  if ( XK[I-1] <  -EPS ) 
   then goto _60;
  R := X[I-1]/XK[I-1];
_50:
  if ( R >=  TETA ) 
   then goto _80;
  TETA := R;
  L := I;
  goto _80;
_60:
  K3 := NX[I-1];
  for J:=1 to KV do
   begin
    K6 := NALFA[J-1];
    if ( K6 <>  K3 ) 
     then goto _70;
    R := (X[I-1] - ALFA[J-1])/XK[I-1];
    goto _50;
_70:
   end;
_80:
 end;
if ( Abs(TETA-A) < EPS1 )
 then L := 0;
if ( A <> -1.0 ) and ( K1 <> K2 )
 then L := L+O16000;
end;

end.
